#
# Revision: 3.0.180532
#
# Copyright (c) 2018 Dell Technologies Inc.
# All rights reserved.
#
# THIS SOFTWARE CONTAINS CONFIDENTIAL INFORMATION AND TRADE SECRETS OF
# DELL EMC CORPORATION. USE, DISCLOSURE OR REPRODUCTION IS PROHIBITED
# WITHOUT THE PRIOR EXPRESS WRITTEN PERMISSION OF DELL EMC.
#
package sc::drtask;
use strict;
use warnings;
use parent 'sc::task';



#@method
#@override
sub properties      { qw (  id
                            name
                            subjectID
                            type
                            taskType
                            method
                            isRunning
                            isFinished
                            isError
                            needDeactivate
                            successful
                            status
                            state
                            totalSteps
                            step
                            stepMessage
                            error
                            errorState
                            warnings
                            restoreState
                            replComplete) }

#@method
sub taskType        { $_[0]->{sc::api::ATTRTaskType()}    || '' }


#@method
sub status          { $_[0]->{sc::api::ATTRStatus()}      || '' }


#@method
sub errorState      { $_[0]->{sc::api::ATTRErrorState()}  || '' }


#@method
sub restoreState    { $_[0]->{sc::api::ATTRRestoreState()} ||'' }


#@method
sub replComplete    { $_[0]->{sc::api::ATTRReplComplete()} || 0 }


#@method
sub subjectID       { $_[0]->{sc::api::ATTRObjectInstance()}->{sc::api::ATTRInstanceId()} }

#@override
#@returns sc::drtask
sub update          { $_[0]->api->inflate($_[0], 'sc::drtask') }


#@method
sub deactivateDR    { $_[0]->POST_ASYNC(sc::api::URLDeactivateDR()) }


#@method
sub needDeactivate  {($_[0]->{sc::api::APIValidObject()}         || 0)  &&
                     ($_[0]->{sc::api::ATTRNeedToDeactivate()}   || 0)  &&
                     ($_[0]->{sc::api::ATTRTaskType()}           eq sc::api::VALUE_Recovery())  &&
                     ($_[0]->{sc::api::ATTRState()}              eq sc::api::VALUE_Running())   &&
                     ($_[0]->{sc::api::ATTRReplComplete()}       >= 100) }


1;