#
# Revision: 3.0.180532
#
# Copyright (c) 2018 Dell Technologies Inc.
# All rights reserved.
#
# THIS SOFTWARE CONTAINS CONFIDENTIAL INFORMATION AND TRADE SECRETS OF
# DELL EMC CORPORATION. USE, DISCLOSURE OR REPRODUCTION IS PROHIBITED
# WITHOUT THE PRIOR EXPRESS WRITTEN PERMISSION OF DELL EMC.
#
package sc::livevolume;
use strict;
use warnings;
use parent 'sc::object';





#@method
#@override
sub properties      { qw (primaryName primarySSN secondaryName secondarySSN id status primaryStatus secondaryStatus replicaState isUp isDrActivated isRepairable) }


#@method
sub deviceId        { $_[0]->{sc::api::ATTRDeviceID()}      || '' };


#@method
sub status          { $_[0]->{sc::api::ATTRStatus()}        || sc::api::STATE_UNKNOWN() }


#@method
sub replicaState    { $_[0]->{sc::api::ATTRReplicationState()} || sc::api::STATE_UNKNOWN() }


#@method
sub primary         { $_[0]->api->inflate($_[0]->{sc::api::ATTRPrimaryVolume()}, 'sc::volume') }


#@method
sub primaryName     { $_[0]->{sc::api::ATTRPrimaryVolume()}->{sc::api::ATTRInstanceName()} }


#@method
sub primaryID       { $_[0]->{sc::api::ATTRPrimaryVolume()}->{sc::api::ATTRInstanceId()} }


#@method
sub primaryRole     { $_[0]->{sc::api::ATTRPrimaryRole()}   || sc::api::STATE_UNKNOWN() }


#@method
sub primaryStatus   { $_[0]->{sc::api::ATTRPrimaryStatus()} || sc::api::STATE_UNKNOWN() }


#@method
sub primarySSN      { $_[0]->{sc::api::ATTRScSSN()}         || '' };


#@method
sub secondary       { $_[0]->api->inflate($_[0]->{sc::api::ATTRSecondaryVolume()}, 'sc::volume') }


#@method
sub secondaryName   { $_[0]->{sc::api::ATTRSecondaryVolume()}->{sc::api::ATTRInstanceName()} }


#@method
sub secondaryID     { $_[0]->{sc::api::ATTRSecondaryVolume()}->{sc::api::ATTRInstanceId()} }


#@method
sub secondaryRole   { $_[0]->{sc::api::ATTRSecondaryRole()}   || sc::api::STATE_UNKNOWN() }


#@method
sub secondaryStatus { $_[0]->{sc::api::ATTRSecondaryStatus()} || sc::api::STATE_UNKNOWN() }


#@method
sub secondarySSN    { $_[0]->{sc::api::ATTRSecondarySSN()}    || '' };


#@method
sub syncMode        { $_[0]->{sc::api::ATTRSyncMode()}  || '' }


#@method
sub syncType        { $_[0]->{sc::api::ATTRSyncType()}  || '' }


#@method
sub isAFO           { $_[0]->{sc::api::ATTRAutoFailover()} || 0 }


#@method
sub isSyncHC        { ($_[0]->syncType eq sc::api::VALUE_Sync) && ($_[0]->syncMode eq sc::api::VALUE_SyncHighConsist) }


#@method
sub isDrActivated   { ($_[0]->secondaryRole eq sc::api::STATE_ACTIVATED) && ($_[0]->secondaryStatus eq sc::api::STATE_UP) }


#@method
sub isUp            { my $self = shift; map { return 0 unless sc::api::STATE_UP eq $self->$_ } qw(status primaryStatus secondaryStatus replicaState); return $self->isValid }


#@method
sub isRepairable    { $_[0]->{sc::api::ATTRRepairable()} }

#@method
#@returns sc::response
sub saveRPoint      { $_[0]->POST(sc::api::URLLvSaveRestorePoint) }

#@method
#@returns sc::response
sub bringOnline     { $_[0]->POST(sc::api::URLBringPrimaryOnline, sc::api::PARAM_LV_ScSerialNumber() => $_[0]->primarySSN) }

#@method
#@returns sc::task
sub swap            { $_[0]->POST_ASYNC(sc::api::URLLvSwapRoles)->asObject('sc::task') }


#@method
sub delete          { $_[0]->DELETE(sc::api::URLLiveVolume(),   ConvertToReplication => 0,
                                                                DeleteRestorePoint => 1,
                                                                DeleteSecondaryVolume => 1,
                                                                RecycleSecondaryVolume => 1) }

1;



#activated                         : 0
#automaticallySwapRoles            : 1
#dedup                             : 0
#downByPolicy                      : 0
#failoverAutomaticallyEnabled      : 0
#failoverState                     : Unprotected
#instanceId                        : 48956.273.60689.318
#instanceName                      : Live Volume of LV6_25
#localTiebreaker                   : 0
#managedReplications               : []
#managedReplicationsAllowed        : 1
#managingReplications              : 0
#minAmountBeforeSwap               : 1048576 Bytes
#minSecondaryPercentBeforeSwap     : 60
#minTimeAsPrimaryBeforeSwap        : 30
#objectType                        : ScLiveVolume
#pauseAllowed                      : 1
#primaryPeerState                  : Connected
#primaryQosNode                    : ScReplicationQosNode{instanceName: Default QOS; instanceId: 60689.1}
#primaryRole                       : Primary
#primaryStatus                     : Up
#primaryStorageCenter              : StorageCenter{instanceName: Storage Center 60689; instanceId: 60689}
#primarySwapRoleState              : NotSwapping
#primaryToTiebreakerConnectivity   : Down
#primaryVolume                     : ScVolume{instanceName: LV6_25; instanceId: 60689.786}
#repairable                        : 0
#repairableMessage                 : Live Volume is not activated
#replicateActiveReplay             : 1
#replicateStorageToLowestTier      : 0
#replicationFound                  : 1
#replicationState                  : Up
#replicationStateMessage           : 0
#restoreAutomaticallyEnabled       : 0
#scName                            : Storage Center 60689
#scSerialNumber                    : 60689
#secondaryPeerState                : Connected
#secondaryQosNode                  : ScReplicationQosNode{instanceName: QOS_Default; instanceId: 48956.1}
#secondaryRole                     : Secondary
#secondaryScSerialNumber           : 48956
#secondaryStatus                   : Up
#secondaryStorageCenter            : StorageCenter{instanceName: Storage Center 48956; instanceId: 48956}
#secondarySwapRoleState            : NotSwapping
#secondaryToTiebreakerConnectivity : Down
#secondaryVolume                   : ScVolume{instanceName: R2_LV6_25; instanceId: 48956.402}
#status                            : Up
#statusMessage                     : 0
#swapRolesAutomaticallyEnabled     : 1
#swappingRoles                     : 0
#syncMode                          : HighAvailability
#syncStatus                        : Current
#transportTypes                    : [FibreChannel; Iscsi]
#type                              : Synchronous



#activated                         : 1
#automaticallySwapRoles            : 0
#dedup                             : 0
#downByPolicy                      : 0
#failoverAutomaticallyEnabled      : 0
#failoverState                     : Unprotected
#instanceId                        : 48956.562.60689.607
#instanceName                      : Live Volume of vcs_02
#localTiebreaker                   : 0
#managedReplications               : []
#managedReplicationsAllowed        : 1
#managingReplications              : 0
#minAmountBeforeSwap               : 1048576 Bytes
#minSecondaryPercentBeforeSwap     : 60
#minTimeAsPrimaryBeforeSwap        : 30
#objectType                        : ScLiveVolume
#pauseAllowed                      : 1
#primaryPeerState                  : Initial
#primaryQosNode                    : ScReplicationQosNode{instanceName: QOS_Default; instanceId: 48956.1}
#primaryRole                       : Primary
#primaryStatus                     : Down
#primaryStorageCenter              : StorageCenter{instanceName: Storage Center 48956; instanceId: 48956}
#primarySwapRoleState              : NotSwapping
#primaryToTiebreakerConnectivity   : Down
#primaryVolume                     : ScVolume{instanceName: vcs_02; instanceId: 48956.886}
#repairable                        : 1
#repairableMessage                 : 0
#replicateActiveReplay             : 1
#replicateStorageToLowestTier      : 1
#replicationFound                  : 1
#replicationState                  : Up
#replicationStateMessage           : 0
#restoreAutomaticallyEnabled       : 0
#scName                            : Storage Center 48956
#scSerialNumber                    : 48956
#secondaryPeerState                : Initial
#secondaryQosNode                  : ScReplicationQosNode{instanceName: Default QOS; instanceId: 60689.1}
#secondaryRole                     : Activated
#secondaryScSerialNumber           : 60689
#secondaryStatus                   : Up
#secondaryStorageCenter            : StorageCenter{instanceName: Storage Center 60689; instanceId: 60689}
#secondarySwapRoleState            : NotSwapping
#secondaryToTiebreakerConnectivity : Down
#secondaryVolume                   : ScVolume{instanceName: vcs_02; instanceId: 60689.1565}
#status                            : Degraded
#statusMessage                     : 0
#swapRolesAutomaticallyEnabled     : 0
#swappingRoles                     : 0
#syncMode                          : HighAvailability
#syncStatus                        : Current
#transportTypes                    : [FibreChannel; Iscsi]
#type                              : Synchronous



#activated                         : 0
#automaticallySwapRoles            : 1
#dedup                             : 0
#downByPolicy                      : 0
#failoverAutomaticallyEnabled      : 0
#failoverState                     : Unprotected
#instanceId                        : 48956.567.60689.612
#instanceName                      : Live Volume of R2_LV0_01
#localTiebreaker                   : 0
#managedReplications               : []
#managedReplicationsAllowed        : 1
#managingReplications              : 0
#minAmountBeforeSwap               : 1048576 Bytes
#minSecondaryPercentBeforeSwap     : 60
#minTimeAsPrimaryBeforeSwap        : 30
#objectType                        : ScLiveVolume
#pauseAllowed                      : 1
#primaryPeerState                  : Connected
#primaryQosNode                    : ScReplicationQosNode{instanceName: QOS_Default; instanceId: 48956.1}
#primaryRole                       : Primary
#primaryStatus                     : Up
#primaryStorageCenter              : StorageCenter{instanceName: Storage Center 48956; instanceId: 48956}
#primarySwapRoleState              : NotSwapping
#primaryToTiebreakerConnectivity   : Down
#primaryVolume                     : ScVolume{instanceName: R2_LV0_01; instanceId: 48956.145}
#repairable                        : 0
#repairableMessage                 : Live Volume is not activated
#replicateActiveReplay             : 1
#replicateStorageToLowestTier      : 0
#replicationFound                  : 1
#replicationState                  : Up
#replicationStateMessage           : 0
#restoreAutomaticallyEnabled       : 0
#scName                            : Storage Center 48956
#scSerialNumber                    : 48956
#secondaryPeerState                : Connected
#secondaryQosNode                  : ScReplicationQosNode{instanceName: Default QOS; instanceId: 60689.1}
#secondaryRole                     : Secondary
#secondaryScSerialNumber           : 60689
#secondaryStatus                   : Up
#secondaryStorageCenter            : StorageCenter{instanceName: Storage Center 60689; instanceId: 60689}
#secondarySwapRoleState            : NotSwapping
#secondaryToTiebreakerConnectivity : Down
#secondaryVolume                   : ScVolume{instanceName: LV0_01; instanceId: 60689.265}
#status                            : Up
#statusMessage                     : 0
#swapRolesAutomaticallyEnabled     : 1
#swappingRoles                     : 0
#syncMode                          : HighConsistency
#syncStatus                        : Current
#transportTypes                    : [FibreChannel; Iscsi]
#type                              : Synchronous



#activated                         : 0
#automaticallySwapRoles            : 1
#dedup                             : 0
#downByPolicy                      : 0
#failoverAutomaticallyEnabled      : 0
#failoverState                     : Unprotected
#instanceId                        : 48956.567.60689.612
#instanceName                      : Live Volume of R2_LV0_01
#localTiebreaker                   : 0
#managedReplications               : []
#managedReplicationsAllowed        : 1
#managingReplications              : 0
#minAmountBeforeSwap               : 1048576 Bytes
#minSecondaryPercentBeforeSwap     : 60
#minTimeAsPrimaryBeforeSwap        : 30
#objectType                        : ScLiveVolume
#pauseAllowed                      : 0
#primaryPeerState                  : Connected
#primaryQosNode                    : ScReplicationQosNode{instanceName: QOS_Default; instanceId: 48956.1}
#primaryRole                       : Primary
#primaryStatus                     : Up
#primaryStorageCenter              : StorageCenter{instanceName: Storage Center 48956; instanceId: 48956}
#primarySwapRoleState              : NotSwapping
#primaryToTiebreakerConnectivity   : Down
#primaryVolume                     : ScVolume{instanceName: R2_LV0_01; instanceId: 48956.145}
#repairable                        : 0
#repairableMessage                 : Live Volume is not activated
#replicateActiveReplay             : 1
#replicateStorageToLowestTier      : 0
#replicationFound                  : 1
#replicationState                  : Paused
#replicationStateMessage           : 0
#restoreAutomaticallyEnabled       : 0
#scName                            : Storage Center 48956
#scSerialNumber                    : 48956
#secondaryPeerState                : Connected
#secondaryQosNode                  : ScReplicationQosNode{instanceName: Default QOS; instanceId: 60689.1}
#secondaryRole                     : Secondary
#secondaryScSerialNumber           : 60689
#secondaryStatus                   : Up
#secondaryStorageCenter            : StorageCenter{instanceName: Storage Center 60689; instanceId: 60689}
#secondarySwapRoleState            : NotSwapping
#secondaryToTiebreakerConnectivity : Down
#secondaryVolume                   : ScVolume{instanceName: LV0_01; instanceId: 60689.265}
#status                            : Up
#statusMessage                     : 0
#swapRolesAutomaticallyEnabled     : 1
#swappingRoles                     : 0
#syncMode                          : HighConsistency
#syncStatus                        : OutOfDate
#transportTypes                    : [FibreChannel; Iscsi]
#type                              : Synchronous