#
# Revision: 3.0.180532
#
# Copyright (c) 2018 Dell Technologies Inc.
# All rights reserved.
#
# THIS SOFTWARE CONTAINS CONFIDENTIAL INFORMATION AND TRADE SECRETS OF
# DELL EMC CORPORATION. USE, DISCLOSURE OR REPRODUCTION IS PROHIBITED
# WITHOUT THE PRIOR EXPRESS WRITTEN PERMISSION OF DELL EMC.
#
package sc::mappingprofile;
use strict;
use warnings;
use parent 'sc::object';





#@method
#@override
sub properties      { qw (volume server lunID lunIDRequested lunIDsUsed connectivity isUp isRO isSC) }


#@method
sub connectivity    { $_[0]->{sc::api::ATTRConnectivity()} || sc::api::STATE_UNKNOWN() }


#@method
sub lunID           { $_[0]->lunIDsUsed == 1 ? $_[0]->lunIDsUsed->[0] : $_[0]->lunIDRequested }


#@method
sub lunIDRequested  { $_[0]->{sc::api::ATTRLunIdRequested()} || '' }


#@method
sub lunIDsUsed      { $_[0]->{sc::api::ATTRLunIdUsed()} || [] }


#@method
sub isUp            { $_[0]->isValid && ($_[0]->connectivity eq sc::api::STATE_UP()) }


#@method
sub isRO            { $_[0]->{sc::api::ATTRReadOnly()} || 0 }


#@method
sub isSC            { $_[0]->{sc::api::ATTRServer()}->{sc::api::ATTRObjectType()} eq sc::api::TYPE_RemoteSC() }


#@method
sub volume          { $_[0]->{sc::api::ATTRVolume()} || {} }


#@method
sub server          { $_[0]->{sc::api::ATTRServer()} || {} }


#@method
sub serverID        { $_[0]->{sc::api::ATTRServer()}->{sc::api::ATTRInstanceId()} || 0 }


#@method
sub volumeID        { $_[0]->{sc::api::ATTRVolume()}->{sc::api::ATTRInstanceId()} || 0 }

#@method
#@returns sc::response
sub makeRO          { $_[0]->POST(sc::api::URLMappingProfileModify, sc::api::PARAM_MAP_AdvancedMapping() => { sc::api::ATTRReadOnly() => 1 }) }

#@method
#@returns sc::response
sub makeRW          { $_[0]->POST(sc::api::URLMappingProfileModify, sc::api::PARAM_MAP_AdvancedMapping() => { sc::api::ATTRReadOnly() => 0 }) }

#@method
#@returns sc::response
sub delete          { $_[0]->DELETE(sc::api::URLMappingProfile()) }


1;


#connectivity   : Up
#controller     : ScController{instanceName: SN 48955; instanceId: 48956.48955}
#hostCache      : 0
#instanceId     : 48956.138
#instanceName   : 123-6
#lunRequested   : 1
#lunUsed        : [1]
#mapCount       : 2
#mappedVia      : Server
#objectType     : ScMappingProfile
#readOnly       : 0
#scName         : Storage Center 48956
#scSerialNumber : 48956
#server         : ScPhysicalServer{instanceName: Veritas-SFHA3; instanceId: 48956.6}
#volume         : ScVolume{instanceName: vcs_volume_01; instanceId: 48956.123}


#API.IsValid    : 1
#API.Session    : sc::api=HASH(0x1c16330)
#connectivity   : Down
#controller     : ScController{instanceName: SN 48955; instanceId: 48956.48955}
#hostCache      : 0
#instanceId     : 48956.142
#instanceName   : 123-5
#lunRequested   : 11
#lunUsed        : []
#mapCount       : 0
#mappedVia      : Server
#objectType     : ScMappingProfile
#readOnly       : 0
#scName         : Storage Center 48956
#scSerialNumber : 48956
#server         : ScPhysicalServer{instanceName: Veritas-SFHA1; instanceId: 48956.5}
#volume         : ScVolume{instanceName: vcs_volume_01; instanceId: 48956.123}


#"AdvancedMapping":{
#        "BootVolume": true,
#        "HostCacheDataPolicy": "EnumValueName",
#        "HostCachePolicy": "EnumValueName",
#        "MapToDownServerHbas": true,
#        "MaximumPathCount": 5,
#        "NoPreferredUseNextAvailable": true,
#        "PreferredController": "12345.67"  (Instance ID),
#        "PreferredLun": 5,
#        "PreferredServerHbaList": ["12345.67"  (Instance ID), "201.4"  (Instance ID)],
#        "PreferredTransport": "EnumValueName",
#        "PreferredTransportTypes": ["EnumValueName", "AnotherEnumValueName"],
#        "ReadOnly": true,
#        "UseNextAvailable": true,
#        "UseSameLunAsSource": true,
#        "VirtualServerMapping": "EnumValueName"
#}