#
# Revision: 3.0.180532
#
# Copyright (c) 2018 Dell Technologies Inc.
# All rights reserved.
#
# THIS SOFTWARE CONTAINS CONFIDENTIAL INFORMATION AND TRADE SECRETS OF
# DELL EMC CORPORATION. USE, DISCLOSURE OR REPRODUCTION IS PROHIBITED
# WITHOUT THE PRIOR EXPRESS WRITTEN PERMISSION OF DELL EMC.
#
package sc::replication;
use strict;
use warnings;
use parent 'sc::object';





#@method
sub properties      { qw (sourceName sourceSSN targetName targetSSN syncType syncMode syncStatus state stateMessage status statusMessage) }

#@method
#@returns sc::response
sub saveRPoint      { $_[0]->POST(sc::api::URLSaveRestorePoint()) }

#@method
#@returns sc::restorepoint
sub restorepoint    { $_[0]->GET(sc::api::URLReplicaRestorePoint())->asObject('sc::restorepoint') }

#@method
#@returns sc::object
sub qosNode         { $_[0]->api->inflate($_[0]->{sc::api::ATTRQosNode()}) }

#@method
#@returns sc::volume
sub sourceVolume    { $_[0]->api->inflate($_[0]->{sc::api::ATTRSourceVolume()}, 'sc::volume') }

#@method
#@returns sc::volume
sub targetVolume    { $_[0]->api->inflate($_[0]->{sc::api::ATTRTargetVolume()}, 'sc::volume') }

#@method
#@returns sc::storagecenter
sub sourceSC        { $_[0]->api->inflate($_[0]->{sc::api::ATTRSourceSC()}, 'sc::storagecenter') }

#@method
#@returns sc::storagecenter
sub targetSC        { $_[0]->api->inflate($_[0]->{sc::api::ATTRTargetSC()}, 'sc::storagecenter') }


#@method
sub sourceVolumeID  { $_[0]->{sc::api::ATTRSourceVolume()}->{sc::api::ATTRInstanceId()} }


#@method
sub targetVolumeID  { $_[0]->{sc::api::ATTRTargetVolume()}->{sc::api::ATTRInstanceId()} }


#@method
sub sourceName      { $_[0]->{sc::api::ATTRSourceVolume()}->{sc::api::ATTRInstanceName()} }


#@method
sub targetName      { $_[0]->{sc::api::ATTRTargetVolume()}->{sc::api::ATTRInstanceName()} }


#@method
sub sourceSSN       { $_[0]->{sc::api::ATTRScSSN()} || 0 }


#@method
sub targetSSN       { $_[0]->{sc::api::ATTRTargetSSN()} || 0 }


#@method
sub state           { $_[0]->{sc::api::ATTRState()} || 0 }


#@method
sub status          { $_[0]->{sc::api::ATTRStatus()} || 0 }


#@method
sub syncStatus      { $_[0]->{sc::api::ATTRSyncStatus()} || '' }


#@method
sub stateMessage    { $_[0]->{sc::api::ATTRStateMessage()}  || '' }


#@method
sub statusMessage   { $_[0]->{sc::api::ATTRStatusMessage()} || '' }


#@method
sub syncMode        { $_[0]->{sc::api::ATTRSyncMode()}  || '' }


#@method
sub syncType        { $_[0]->{sc::api::ATTRSyncType()}  || '' }


#@method
sub transport       { @{$_[0]->{sc::api::ATTRTransportTypes()}||[]} }


#@method
sub transportSec    { @{$_[0]->{sc::api::ATTRTransportTypesSec()}||[]} }


#@method
sub isManagedByLV   { $_[0]->{sc::api::ATTRManagedByLV()}   || 0 }


#@method
sub isPauseAllowed  { $_[0]->{sc::api::ATTRPauseAllowed()}  || 0 }


#@method
sub isActiveSnap    { $_[0]->{sc::api::ATTRReplicateActReplay()} || 0 }


#@method
sub isLowestTier    { $_[0]->{sc::api::ATTRToLowestTier()}  || 0 }


#@method
sub isSimulation    { $_[0]->{sc::api::ATTRSimulation()}    || 0 }


#@method
sub isUp            { $_[0]->isValid && ($_[0]->state eq sc::api::STATE_UP) && ($_[0]->status eq sc::api::STATE_UP) }


#@method
sub isSyncHC        { ($_[0]->syncType eq sc::api::VALUE_Sync) && ($_[0]->syncMode eq sc::api::VALUE_SyncHighConsist) }


1;





#dedup                        : 0
#destinationScSerialNumber    : 48956
#destinationStorageCenter     : StorageCenter{instanceName: Storage Center 48956; instanceId: 48956}
#destinationVolume            : ScVolume{instanceName: R2_LV0_01; instanceId: 48956.145}
#instanceId                   : 60689.145
#instanceName                 : Replication of LV0_01
#managedByLiveVolume          : 0
#objectType                   : ScReplication
#pauseAllowed                 : 1
#qosNode                      : ScReplicationQosNode{instanceName: Default QOS; instanceId: 60689.1}
#replicateActiveReplay        : 1
#replicateStorageToLowestTier : 0
#scName                       : Storage Center 60689
#scSerialNumber               : 60689
#secondaryTransportTypes      : []
#simulation                   : 0
#sourceStorageCenter          : StorageCenter{instanceName: Storage Center 60689; instanceId: 60689}
#sourceVolume                 : ScVolume{instanceName: LV0_01; instanceId: 60689.265}
#state                        : Up
#stateMessage                 : 0
#status                       : Up
#statusMessage                : 0
#syncMode                     : HighAvailability
#syncStatus                   : Current
#transportTypes               : [FibreChannel; Iscsi]
#type                         : Synchronous



#dedup                        : 0
#destinationScSerialNumber    : 48956
#destinationStorageCenter     : StorageCenter{instanceName: Storage Center 48956; instanceId: 48956}
#destinationVolume            : ScVolume{instanceName: R2_LV0_01; instanceId: 48956.145}
#instanceId                   : 60689.145
#instanceName                 : Replication of LV0_01
#managedByLiveVolume          : 0
#objectType                   : ScReplication
#pauseAllowed                 : 1
#qosNode                      : ScReplicationQosNode{instanceName: Default QOS; instanceId: 60689.1}
#replicateActiveReplay        : 1
#replicateStorageToLowestTier : 0
#scName                       : Storage Center 60689
#scSerialNumber               : 60689
#secondaryTransportTypes      : []
#simulation                   : 0
#sourceStorageCenter          : StorageCenter{instanceName: Storage Center 60689; instanceId: 60689}
#sourceVolume                 : ScVolume{instanceName: LV0_01; instanceId: 60689.265}
#state                        : Up
#stateMessage                 : 0
#status                       : Up
#statusMessage                : 0
#syncMode                     : HighConsistency
#syncStatus                   : OutOfDate
#transportTypes               : [FibreChannel; Iscsi]
#type                         : Synchronous



#dedup                        : 0
#destinationScSerialNumber    : 48956
#destinationStorageCenter     : StorageCenter{instanceName: Storage Center 48956; instanceId: 48956}
#destinationVolume            : ScVolume{instanceName: R2_LV0_01; instanceId: 48956.145}
#instanceId                   : 60689.145
#instanceName                 : Replication of LV0_01
#managedByLiveVolume          : 0
#objectType                   : ScReplication
#pauseAllowed                 : 0
#qosNode                      : ScReplicationQosNode{instanceName: Default QOS; instanceId: 60689.1}
#replicateActiveReplay        : 1
#replicateStorageToLowestTier : 0
#scName                       : Storage Center 60689
#scSerialNumber               : 60689
#secondaryTransportTypes      : []
#simulation                   : 0
#sourceStorageCenter          : StorageCenter{instanceName: Storage Center 60689; instanceId: 60689}
#sourceVolume                 : ScVolume{instanceName: LV0_01; instanceId: 60689.265}
#state                        : Paused
#stateMessage                 : 0
#status                       : Degraded
#statusMessage                : 0
#syncMode                     : HighAvailability
#syncStatus                   : OutOfDate
#ransportTypes                : [FibreChannel; Iscsi]
#type                         : Synchronous



#dedup                        : 0
#destinationScSerialNumber    : 48956
#destinationStorageCenter     : StorageCenter{instanceName: Storage Center 48956; instanceId: 48956}
#destinationVolume            : ScVolume{instanceName: R2_LV0_01; instanceId: 48956.145}
#instanceId                   : 60689.145
#instanceName                 : Replication of LV0_01
#managedByLiveVolume          : 0
#objectType                   : ScReplication
#pauseAllowed                 : 0
#qosNode                      : ScReplicationQosNode{instanceName: Default QOS; instanceId: 60689.1}
#replicateActiveReplay        : 0
#replicateStorageToLowestTier : 0
#scName                       : Storage Center 60689
#scSerialNumber               : 60689
#secondaryTransportTypes      : []
#simulation                   : 0
#sourceStorageCenter          : StorageCenter{instanceName: Storage Center 60689; instanceId: 60689}
#sourceVolume                 : ScVolume{instanceName: LV0_01; instanceId: 60689.265}
#state                        : Paused
#stateMessage                 : 0
#status                       : Degraded
#statusMessage                : 0
#syncMode                     : None
#syncStatus                   : NotApplicable
#transportTypes               : [FibreChannel; Iscsi]
#type                         : Asynchronous