#
# Revision: 3.0.180532
#
# Copyright (c) 2018 Dell Technologies Inc.
# All rights reserved.
#
# THIS SOFTWARE CONTAINS CONFIDENTIAL INFORMATION AND TRADE SECRETS OF
# DELL EMC CORPORATION. USE, DISCLOSURE OR REPRODUCTION IS PROHIBITED
# WITHOUT THE PRIOR EXPRESS WRITTEN PERMISSION OF DELL EMC.
#
package sc::task;
use strict;
use warnings;
use parent 'sc::object';



#@method
#@override
sub properties      { qw (  id
                            name
                            type
                            method
                            isRunning
                            isFinished
                            isError
                            successful
                            state
                            error
                            step
                            stepMessage
                            totalSteps
                            warnings
                            ) }

#@method
sub state           { $_[0]->{sc::api::ATTRState()}       || '' }


#@method
sub totalSteps      { $_[0]->{sc::api::ATTRTotalSteps()}  || 0  }


#@method
sub step            { $_[0]->{sc::api::ATTRCurrentStep()} || 0  }


#@method
sub stepMessage     { $_[0]->{sc::api::ATTRStepMessage()} || '' }


#@method
sub error           { $_[0]->{sc::api::ATTRError()}       || '' }


#@method
sub warnings        { $_[0]->{sc::api::ATTRWarningList()} || [] }


#@method
sub method          { $_[0]->{sc::api::ATTRMethodName()}  || '' }


#@method
sub successful      { $_[0]->{sc::api::ATTRSuccessful()}  || '' }


#@method
sub isRunning       { $_[0]->isValid && ($_[0]->state eq sc::api::STATE_RUNNING()) }


#@method
sub isError         { $_[0]->isValid && ($_[0]->state eq sc::api::STATE_ERROR()) }


#@method
sub isFinished      { $_[0]->isValid && ($_[0]->state eq sc::api::STATE_FINISHED()) }

#@method
#@returns sc::task
sub update          { $_[0]->api->inflate($_[0], 'sc::task') }



1;